/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SENT                                                     */
/* Tabela : SERIEENTR                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 18/06/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_SENT
BEFORE INSERT OR UPDATE OR DELETE
ON SERIEENTR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUSENT := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDSERIEENTR,0) <> NVL(:NEW.CDSERIEENTR,0)) OR
         (NVL(:OLD.DSSERIEENTR,0) <> NVL(:NEW.DSSERIEENTR,0)) THEN
         :NEW.DTULTATUSENT := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('SERIEENTR', '', 'CDSERIEENTR='||:OLD.CDSERIEENTR||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE SERIEENTR MODIFY DTULTATUSENT DEFAULT SYSDATE
/
