/*
TECNISA TECNOLOGIA EM INFORMTICA
CRIAO: ANA PAULA DA SILVA
DATA: 29/04/2002
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE
           O.NAME = 'ORIGDESTNF' AND
           TYPE = 'V' 		      AND
           U.UID = O.UID         AND
           U.NAME = USER)

DROP VIEW ORIGDESTNF
GO

CREATE VIEW ORIGDESTNF AS

SELECT N.CDFILIAL, N.NRLANCTONF,
       N.CDPAISDEST, N.SGESTADEST, N.CDMUNIDEST, ED.CDESTAEXPO AS CDESTADEST,
       N.CDPAISORIG, N.SGESTAORIG, N.CDMUNIORIG, EO.CDESTAEXPO AS CDESTAORIG,
       PO.NMPAIS AS NMPAISORIG,
       MO.NMMUNICIPIO AS NMMUNIORIG,
       PD.NMPAIS AS NMPAISDEST,
       MD.NMMUNICIPIO AS NMMUNIDEST,
       N.CDPAISMOVI, N.SGESTAMOVI, N.CDMUNIMOVI,
       N.CDPAISCFOP, N.SGESTACFOP, N.CDMUNICFOP,
       E.CDESTAEXPO, M.CDMUNIEXPO, M.IDMUNIALC
FROM PAIS PO, PAIS PD, MUNICIPIO MO, MUNICIPIO MD, ESTADO E, MUNICIPIO M,
     ESTADO EO, ESTADO ED,
     (SELECT N.CDFILIAL, N.NRLANCTONF,
             ISNULL(EF.CDPAIS, ISNULL(EC.CDPAIS, EL.CDPAIS)) AS CDPAISDEST,
             ISNULL(EF.SGESTADO, ISNULL(EC.SGESTADO, EL.SGESTADO)) AS SGESTADEST,
             ISNULL(EF.CDMUNICIPIO, ISNULL(EC.CDMUNICIPIO, EL.CDMUNICIPIO)) AS CDMUNIDEST,
             IE.CDPAIS AS CDPAISORIG,
             IE.SGESTADO AS SGESTAORIG,
             IE.CDMUNICIPIO AS CDMUNIORIG,
             ISNULL(EF.CDPAIS, ISNULL(EC.CDPAIS, EL.CDPAIS)) AS CDPAISMOVI,
             ISNULL(EF.SGESTADO, ISNULL(EC.SGESTADO, EL.SGESTADO)) AS SGESTAMOVI,
             ISNULL(EF.CDMUNICIPIO, ISNULL(EC.CDMUNICIPIO, EL.CDMUNICIPIO)) AS CDMUNIMOVI,
             ISNULL(FCF.CDPAIS, ISNULL(CCF.CDPAIS, LCF.CDPAIS)) AS CDPAISCFOP,
             ISNULL(FCF.SGESTADO, ISNULL(CCF.SGESTADO, LCF.SGESTADO)) AS SGESTACFOP,
             ISNULL(FCF.CDMUNICIPIO, ISNULL(CCF.CDMUNICIPIO, LCF.CDMUNICIPIO)) AS CDMUNICFOP
      FROM NOTAFISCAL N LEFT JOIN FORNECEDOR F ON
           (N.CDFORNECED = F.CDFORNECED)
                        LEFT JOIN CLIENTE C ON
           (N.CDCLIENTE  = C.CDCLIENTE)
                        LEFT JOIN FILIAL L ON
           (N.CDFILIRECE = L.CDFILIAL)
                        LEFT JOIN ENDEFORN EF ON
           (F.CDFORNECED = EF.CDFORNECED) AND
           (ISNULL(F.IDENDEMISFOR, 'P') = EF.IDTPENDEFORN)
                        LEFT JOIN ENDECLIE EC ON
           (C.CDCLIENTE  = EC.CDCLIENTE) AND
           (ISNULL(C.IDENDEMISCLI, 'P') = EC.IDTPENDECLIE)
                        LEFT JOIN ENDEFILI EL ON
           (L.CDFILIAL   = EL.CDFILIAL) AND
           (ISNULL(L.IDENDEMISFIL, 'P') = EL.IDTPENDEFILI)
                        LEFT JOIN ENDEFORN FCF ON
           (F.CDFORNECED = FCF.CDFORNECED) AND
           (ISNULL(F.IDENDCFOPFOR, 'P') = FCF.IDTPENDEFORN)
                        LEFT JOIN ENDECLIE CCF ON
           (C.CDCLIENTE  = CCF.CDCLIENTE) AND
           (ISNULL(C.IDENDCFOPCLI, 'P') = CCF.IDTPENDECLIE)
                        LEFT JOIN ENDEFILI LCF ON
           (L.CDFILIAL   = LCF.CDFILIAL) AND
           (ISNULL(L.IDENDCFOPFIL, 'P') = LCF.IDTPENDEFILI),
           INSCRESTAD IE
      WHERE N.CDEMPRESA  = IE.CDEMPRESA      AND
            N.CDINSCESTA = IE.CDINSCESTA     AND
            N.IDENTRSAIDOP = 'S'
      UNION ALL
      SELECT N.CDFILIAL, N.NRLANCTONF,
             IE.CDPAIS AS CDPAISDEST,
             IE.SGESTADO AS SGESTADEST,
             IE.CDMUNICIPIO AS CDMUNIDEST,
             ISNULL(EF.CDPAIS, ISNULL(EC.CDPAIS, EL.CDPAIS)) AS CDPAISORIG,
             ISNULL(EF.SGESTADO, ISNULL(EC.SGESTADO, EL.SGESTADO)) AS SGESTAORIG,
             ISNULL(EF.CDMUNICIPIO, ISNULL(EC.CDMUNICIPIO, EL.CDMUNICIPIO)) AS CDMUNIORIG,
             ISNULL(EF.CDPAIS, ISNULL(EC.CDPAIS, EL.CDPAIS)) AS CDPAISMOVI,
             ISNULL(EF.SGESTADO, ISNULL(EC.SGESTADO, EL.SGESTADO)) AS SGESTAMOVI,
             ISNULL(EF.CDMUNICIPIO, ISNULL(EC.CDMUNICIPIO, EL.CDMUNICIPIO)) AS CDMUNIMOVI,
             ISNULL(FCF.CDPAIS, ISNULL(CCF.CDPAIS, LCF.CDPAIS)) AS CDPAISCFOP,
             ISNULL(FCF.SGESTADO, ISNULL(CCF.SGESTADO, LCF.SGESTADO)) AS SGESTACFOP,
             ISNULL(FCF.CDMUNICIPIO, ISNULL(CCF.CDMUNICIPIO, LCF.CDMUNICIPIO)) AS CDMUNICFOP
      FROM NOTAFISCAL N LEFT JOIN FORNECEDOR F ON
           (N.CDFORNECED = F.CDFORNECED)
                        LEFT JOIN CLIENTE C ON
           (N.CDCLIENTE  = C.CDCLIENTE)
                        LEFT JOIN FILIAL L ON
           (N.CDFILIEMIT = L.CDFILIAL)
                        LEFT JOIN ENDEFORN EF ON
           (F.CDFORNECED = EF.CDFORNECED) AND
           (ISNULL(F.IDENDEMISFOR, 'P') = EF.IDTPENDEFORN)
                        LEFT JOIN ENDECLIE EC ON
           (C.CDCLIENTE  = EC.CDCLIENTE) AND
           (ISNULL(C.IDENDEMISCLI, 'P') = EC.IDTPENDECLIE)
                        LEFT JOIN ENDEFILI EL ON
           (L.CDFILIAL   = EL.CDFILIAL) AND
           (ISNULL(L.IDENDEMISFIL, 'P') = EL.IDTPENDEFILI)
                        LEFT JOIN ENDEFORN FCF ON
           (F.CDFORNECED = FCF.CDFORNECED) AND
           (ISNULL(F.IDENDCFOPFOR, 'P') = FCF.IDTPENDEFORN)
                        LEFT JOIN ENDECLIE CCF ON
           (C.CDCLIENTE  = CCF.CDCLIENTE) AND
           (ISNULL(C.IDENDCFOPCLI, 'P') = CCF.IDTPENDECLIE)
                        LEFT JOIN ENDEFILI LCF ON
           (L.CDFILIAL   = LCF.CDFILIAL) AND
           (ISNULL(L.IDENDCFOPFIL, 'P') = LCF.IDTPENDEFILI),
           INSCRESTAD IE
      WHERE N.CDEMPRESA  = IE.CDEMPRESA      AND
            N.CDINSCESTA = IE.CDINSCESTA     AND
            N.IDENTRSAIDOP = 'E') N
WHERE N.CDPAISDEST = PD.CDPAIS      AND
      N.CDPAISDEST = ED.CDPAIS      AND
      N.SGESTADEST = ED.SGESTADO    AND
      N.CDPAISDEST = MD.CDPAIS      AND
      N.SGESTADEST = MD.SGESTADO    AND
      N.CDMUNIDEST = MD.CDMUNICIPIO AND
      N.CDPAISORIG = PO.CDPAIS      AND
      N.CDPAISORIG = EO.CDPAIS      AND
      N.SGESTAORIG = EO.SGESTADO    AND
      N.CDPAISORIG = MO.CDPAIS      AND
      N.SGESTAORIG = MO.SGESTADO    AND
      N.CDMUNIORIG = MO.CDMUNICIPIO AND
      N.CDPAISMOVI = M.CDPAIS       AND
      N.SGESTAMOVI = M.SGESTADO     AND
      N.CDMUNIMOVI = M.CDMUNICIPIO  AND
      N.CDPAISCFOP = E.CDPAIS       AND
      N.SGESTACFOP = E.SGESTADO
GO
